<?php
class CMS {
	//load method
	public static function load($page,$element) {
		//can't load users variable
		if($page==='site_variables' && $element==='users') return false;
		
		global $language;
	
		//if in preview mode
		if($_SESSION['cms_logged_in'] && $_REQUEST['preview'] && $_REQUEST['page']==$page && $_REQUEST['element']==$element) {
			if(isset($_REQUEST['revision'])) {
				return CMS::parseBBCode(file_get_contents(SITE_FOLDER."cms/revisions/$_REQUEST[page]/$_REQUEST[element]/$_REQUEST[revision].r"));
			}
			else return CMS::parseBBCode($_REQUEST['data']);
		}
		else {
			//in mobile mode
			if($_SESSION['mobile']) {
				//mobile page exists
				if(file_exists(SITE_FOLDER."cms/pages/$page"."_mobile.php")) {
					//mobile and language on mobile page
					if(file_exists(SITE_FOLDER."cms/page_content/".$page."_mobile/$element.mobile.$language.php")) {
						$file = SITE_FOLDER."cms/page_content/".$page."_mobile/$element.mobile.$language.php";
					}
					//mobile on mobile page
					elseif(file_exists(SITE_FOLDER."cms/page_content/".$page."_mobile/$element.mobile.php")) {
						$file = SITE_FOLDER."cms/page_content/".$page."_mobile/$element.mobile.php";
					}
					//language on mobile page
					elseif(file_exists(SITE_FOLDER."cms/page_content/".$page."_mobile/$element.$language.php")) {
						$file = SITE_FOLDER."cms/page_content/".$page."_mobile/$element.$language.php";
					}
					//element on mobile page
					elseif(file_exists(SITE_FOLDER."cms/page_content/".$page."_mobile/$element.php")) {
						$file = SITE_FOLDER."cms/page_content/".$page."_mobile/$element.php";
					}
				}
				if(!$file) {
					//mobile and language
					if(file_exists(SITE_FOLDER."cms/page_content/$page/$element.mobile.$language.php")) {
						$file = SITE_FOLDER."cms/page_content/$page/$element.mobile.$language.php";
					}
					//mobile
					elseif(file_exists(SITE_FOLDER."cms/page_content/$page/$element.mobile.php")) {
						$file = SITE_FOLDER."cms/page_content/$page/$element.mobile.php";
					}
				}
			}
			if(!$file) {
				//language
				if(file_exists(SITE_FOLDER."cms/page_content/$page/$element.$language.php")) {
					$file = SITE_FOLDER."cms/page_content/$page/$element.$language.php";
				}
				//plain element
				elseif(file_exists(SITE_FOLDER."cms/page_content/$page/$element.php")) {
					$file = SITE_FOLDER."cms/page_content/$page/$element.php";
				}
				//not found
				else return false;
			}
			
			return CMS::parseBBCode(file_get_contents($file));
		}
	}
	public static function loadPage($page) {	
		//remove .php
		$page = explode('.',$page);
		array_pop($page);
		$page = implode('.',$page);
		
		//don't load header, footer, or style_sheets
		if(in_array($page,array('header','footer','style_sheets','header_mobile','footer_mobile'))) return false;
		
		if($_SESSION['cms_logged_in'] && $_REQUEST['preview'] && $_REQUEST['page']==$page && !$_REQUEST['element']) {
			if($_REQUEST['revision']) $file = SITE_FOLDER."cms/revisions/$_REQUEST[page]/$_REQUEST[element]/$_REQUEST[revision].r";
			else {
				//create temp file
				$file = SITE_FOLDER."cms/revisions/$_REQUEST[page].temp";
				file_put_contents($file,$_REQUEST['data']);
				$remove_temp_file = true;
			}
		}
		elseif($_SESSION['mobile'] && file_exists(SITE_FOLDER."cms/pages/".$page."_mobile.php")) {
			$file = SITE_FOLDER."cms/pages/".$page."_mobile.php";
		}
		else {
			$file = SITE_FOLDER."cms/pages/$page.php";
		}
		if(file_exists($file)) {
			ob_start();
			global $meta, $title, $hidetitle;
			$hidetitle = true;
			$title = CMS::load($page,'title');
			
			//load meta description
			$meta = array();
			$meta['description'] = CMS::load($page,'meta_description');
			if($meta['description'] === false) {
				$meta['description'] = CMS::load('site_variables','meta_description');
			}
			
			//load meta content-type
			$meta['content-type'] = CMS::load($page,'meta_content_type');
			if($meta['content-type'] === false) {
				$meta['content-type'] = CMS::load('site_variables','meta_content_type');
			}
			
			include_header();
			if($_SESSION['cms_logged_in'] && $_REQUEST['preview']) {
			global $site_root;
			?>
			<img src='<?php echo $site_root; ?>images/preview.gif' style='position:absolute; width: 150px; height: 150px; top:0; right:0;' />
			<?php
			}
			ob_start();
			include $file;
			$temp = ob_get_contents();
			ob_end_clean();
			echo CMS::parsePage($temp,$page);
			//echo CMS::parsePage(file_get_contents($file),$page);
			footer();
			$return = ob_get_contents();
			ob_end_clean();
			
			//remove temp file
			if($remove_temp_file) unlink($file);
			
			return $return;
		}
			
		else return false;
	}
	
	public static function parsePage($text, $page) {
		global $site_root;
		$search = array(
			//[var]site_root[/var]
			'/\[var\]((.(?!\[\/var\]))+.)\[\/var\]/e',
			
			//[sitevar]business_name[/sitevar]
			'/\[sitevar\]((.(?!\[\/sitevar]))+.)\[\/sitevar\]/e',
			
			//[cms]page - element[/cms]
			'/\[cms\]\s*([a-zA-Z0-9\-_]+)\s*\-\s*([a-zA-Z0-9\-_]+)\s*\[\/cms\]/e',
			
			//[cms]element[/cms]
			'/\[cms\]\s*([a-zA-Z0-9\-_]+)\s*\[\/cms\]/e',
		
			//[url]http://google.com[/url]
			'/\[url\]((http|ftp|https)[^\[]*)\[\/url\]/',
			
			//[url]email@domain.com[/url]
			'/\[url\](([^\[])+@([^\[])+\.([^\[])+)\[\/url\]/',
			
			//[url]pricing.pdf[/url]
			'/\[url\]([^\[]*\.[a-zA-Z0-9]+)\[\/url\]/',
			
			//[url]home/[/url]
			'/\[url\]([^\[]*)\[\/url\]/',
			
			//[url=http://google.com]Google[/url]
			'/\[url=((http|ftp|https)[^\]]*)\]([^\[]*)\[\/url\]/',
			
			//[url=email@domain.com]Email[/url]
			'/\[url=(([^\]])+@([^\]])+\.([^\]])+)\]([^\[]*)\[\/url\]/',
			
			//[url=pricing.pdf]download[/url]
			'/\[url=([^\]]*\.[a-zA-Z0-9]+)\]([^\[]*)\[\/url\]/',
			
			//[url=about/]About Us[/url]
			'/\[url=([^\]]*)\]([^\[]*)\[\/url\]/',
			
			//[img]image_file.jpg[/img]
			'/\[img\]([^\[]*)\[\/img\]/',
		);
		$replace = array(
			//[var]site_root[/var]
			"getVar('\\1')",
			
			//[sitevar]business_name[/sitevar]
			"CMS::load('site_variables','\\1')",
			
			//[cms]page - element[/cms]
			"CMS::load('\\1','\\2')",
			
			//[cms]element[/cms]
			"CMS::load('$page','\\1')",
			
			//[url]http://google.com[/url]
			'<a href="$1">$1</a>',
			
			//[url]email@domain.com[/url]
			'<a href="mailto:$1">$1</a>',
			
			//[url]pricing.pdf[/url]
			'<a href="'.$site_root.'files/$1">$1</a>',
			
			//[url]home/[/url]
			'<a href="'.$site_root.'$1">$1</a>',
			
			//[url=http://google.com]Google[/url]
			'<a href="$1">$3</a>',
			
			//[url=email@domain.com]Email[/url]
			'<a href="mailto:$1">$5</a>',
			
			//[url=pricing.pdf]download[/url]
			'<a href="'.$site_root.'files/$1">$2</a>',
			
			//[url=about/]About Us[/url]
			'<a href="'.$site_root.'$1">$2</a>',
			
			//[img]image_file.jpg[/img]
			'<img src="'.$site_root.'uploadedimages/$1" class="cms_image"/>'		
		);
		
		return preg_replace($search,$replace,$text);	
	}
	
	public static function parseBBCode($text) {
		global $site_root;
		$search = array(
			//[url]http://google.com[/url]
			'/\[url\]((http|ftp|https)[^\[]*)\[\/url\]/',
			
			//[url]email@domain.com[/url]
			'/\[url\](([^\[])+@([^\[])+\.([^\[])+)\[\/url\]/',
			
			//[cms]page - element[/cms]
			'/\[cms\]\s*([a-zA-Z0-9\-_]+)\s*\-\s*([a-zA-Z0-9\-_]+)\s*\[\/cms\]/e',
			
			//[sitevar]business_name[/sitevar]
			'/\[sitevar\]((.(?!\[\/sitevar]))+.)\[\/sitevar\]/e',
			
			//[url]pricing.pdf[/url]
			'/\[url\]([^\[]*\.[a-zA-Z0-9]+)\[\/url\]/',
			
			//[url]home/[/url]
			'/\[url\]([^\[]*)\[\/url\]/',
			
			//[url=http://google.com]Google[/url]
			'/\[url=((http|ftp|https)[^\]]*)\]([^\[]*)\[\/url\]/',
			
			//[url=email@domain.com]Email[/url]
			'/\[url=(([^\]])+@([^\]])+\.([^\]])+)\]([^\[]*)\[\/url\]/',
			
			//[url=pricing.pdf]download[/url]
			'/\[url=([^\]]*\.[a-zA-Z0-9]+)\]([^\[]*)\[\/url\]/',
			
			//[url=about/]About Us[/url]
			'/\[url=([^\]]*)\]([^\[]*)\[\/url\]/',
			
			//[img]image_file.jpg[/img]
			'/\[img\]([^\[]*)\[\/img\]/',
		);
		$replace = array(
			//[url]http://google.com[/url]
			'<a href="$1">$1</a>',
			
			//[url]email@domain.com[/url]
			'<a href="mailto:$1">$1</a>',
			
			//[cms]page - element[/cms]
			"CMS::load('\\1','\\2')",
			
			//[sitevar]business_name[/sitevar]
			"CMS::load('site_variables','\\1')",
			
			//[url]pricing.pdf[/url]
			'<a href="'.$site_root.'files/$1">$1</a>',
			
			//[url]home/[/url]
			'<a href="'.$site_root.'$1">$1</a>',
			
			//[url=http://google.com]Google[/url]
			'<a href="$1">$3</a>',
			
			//[url=email@domain.com]Email[/url]
			'<a href="mailto:$1">$5</a>',
			
			//[url=pricing.pdf]download[/url]
			'<a href="'.$site_root.'files/$1">$2</a>',
			
			//[url=about/]About Us[/url]
			'<a href="'.$site_root.'$1">$2</a>',
			
			//[img]image_file.jpg[/img]
			'<img src="'.$site_root.'uploadedimages/$1" class="cms_image" />'		
		);
		
		return preg_replace($search,$replace,$text);
	}
	
	public static function parse($cms_code,$headers) {
		$return = csv_to_array($cms_code);
		
		foreach($return as &$row) {
			$row = array_combine($headers,$row);
		}
		return $return;
	}
	
	public static function parseForm($cms_code) {
		return CMS::parse($cms_code,array('label','type','options'));
	}
	
	//generate methods
	public static function generateForm($fields,$email = false) {
		global $site_root;
		if(!$email) $email = TO_EMAIL;
	
		//parse if not done already
		if(!is_array($fields)) $fields = CMS::parseForm($fields);
	
		$return = array();
		foreach($fields as $key=>$field) {
			$id = trim(strtolower(str_replace(' ','_',$field['label'])));
			$temp = "<label for='$id'>".$field['label']."</label>";
			switch($field['type']) {
				case "text":
					$temp .= "<input type='text' name='$id' id='$id' value=\"".$field['options']."\"/>";
					break;
				case "date":
					$temp .= "<input type='text' name='$id' id='$id' style='width:100px;' class='date_input' value=\"".$field['options']."\"/>";
					break;
				case "password":
					$temp .= "<input type='password' name='$id' id='$id'/>";
					break;
				case "textarea":
					$temp .= "<textarea cols='40' rows='3' name='$id' id='$id'>".$field['options']."</textarea>";
					break;
				case "select":
				case "dropdown":
					$temp .= "<select name='$id' id='$id'>";
					$options = explode(',',$field['options']);
					foreach($options as $option) {
						$temp .= "<option value=\"$option\">$option</option>";
					}
					$temp .= "</select>";
					break;
				case "country":
					$temp .= "<select name='$id' id='$id'>".file_get_contents('includes/countrylist.html')."</select>";
					break;
				case "state":
					$temp .= "<select name='$id' id='$id'>".file_get_contents('includes/statelist.html')."</select>";
					break;
				case "captcha":
				case "verification":
					$captcha = $id;
					$temp .= "<div style='margin-left: 130px;margin-top:5px;'><img src='{$site_root}images/captcha/' style='vertical-align:middle;'/><br/><input type='text' name='$id' id='$id' style='margin:5px 0 0 0; width:160px;'></div>";
					break;
				case "time":
					$options = explode(',',$field['options']);
					$hour_range = explode('-',$options[0]);
					if(count($hour_range) != 2) $hour_range = array(9,5);
					else $hour_range = array(intval($hour_range[0]),intval($hour_range[1]));
					if($hour_range[0] > 12) $hour_range[0] = 12;
					elseif($hour_range[0] < 1) $hour_range[0] = 1;
					if($hour_range[1] > 12) $hour_range[1] = 12;
					elseif($hour_range[1] < 1) $hour_range[1] = 1;
					if(isset($options[1])) {
						$minute_increment = intval($options[1]);
						if($minute_increment < 1) $minute_increment = 1;
						elseif($minute_increment > 60) $minute_increment = 60;
					}
					else $minute_increment = 5;			

					$j = 0;
					$temp .= "<input type='hidden' name='$id' id='$id' />";
					$temp .= "<select id='{$id}_hour' class='time_hour' class='time_hour'>";
					for($i=$hour_range[0];$i!=($hour_range[1]+1)%13;$i = ($i+1)%13) {
						if($i == 0) $i = 1;
						$temp .= "<option value='$i'>".(($i<10)? '0' : '').$i."</option>";
						
						//safeguard
						$j++;
						if($j > 24) break;
					}
					$temp .= "</select><span style='padding: 0 3px; font-weight:bold;'>:</span><select id='{$id}_minutes' class='time_minutes' style='margin-left:0;'>";
					for($i=0;$i<60;$i+=$minute_increment) {
						$temp .= "<option value='$i'>".(($i<10)? '0' : '').$i."</option>";
					}
					$temp .= "</select> <select id='{$id}_ampm' class='time_ampm' style='margin-left:0;'><option>AM</option><option>PM</option></select>";
					break;
			}
			$return [] = $temp;
		}
		
		//form submitted
		if($_POST['submit'] && $email) {
			ob_start();
			if($captcha && $_SESSION['captcha'] != $_POST[$captcha]) {
				echo alert(translate("Verification codes do not match").'.');
			}
			else {
				//generate email message
				$subject = "form submitted";
				$message = "";
				foreach($_POST as $key=>$value) {
					if($key == 'submit') continue;
					$message .= "$key: $value\n";
				}
				
				require_once 'mailer/swift_required.php';
				
				//get transport
				global $email_settings;
				switch($email_settings['type']) {
					case 'mail':
						$transport = Swift_MailTransport::newInstance();
						break;
					case 'sendmail':
						if(!$email_settings['command']) $email_settings['command'] = '/usr/sbin/sendmail -bs';
						$transport = Swift_SendmailTransport::newInstance($email_settings['command']);
						break;
					case 'smtp':
						if(!$email_settings['port']) $email_settings['port'] = '25';
						$transport = Swift_SmtpTransport::newInstance($email_settings['host'], $email_settings['port']);
						if($email_settings['username']) $transport->setUsername($email_settings['username']);
						if($email_settings['password']) $transport->setPassword($email_settings['password']);
				}

				$mailer = Swift_Mailer::newInstance($transport);

				$email = Swift_Message::newInstance()
				->setSubject($subject)
				->setFrom(FROM_EMAIL)
				->setTo($email)
				->setBody($message);
				
				ob_start();			
				//Send the message
				$result = $mailer->send($email);
				$error = ob_get_contents();
				ob_end_clean();
				
				if($result)
					echo notice(translate("Form successfully submitted").'.')."<br/>";
				else {
					echo alert(translate("There was a problem submitting the form").'.')."<br/>";
					print_debug($error,1);
				}
			}
			$message = ob_get_contents();
			ob_end_clean();
		}
		
		$return = $message."<form method='post' action='?' class='standard_form'>".implode("<br/>",$return)."<br/><input type='submit' name='submit' value='".translate('Submit')."' class='ui-state-default ui-corner-all ui-button' /></form>";

	if(!$_SESSION['mobile']) {
		global $site_root;
		ob_start();
		?>
<script type="text/javascript">
$(document).ready(function() {	
	$(".date_input").datepicker({
		showOn: "both",
		buttonImage: "<?php echo $site_root; ?>images/icons/Dates.png",
		buttonImageOnly: true
	});
	$(".time_hour, .time_minutes, .time_ampm").change(function() {	
		//get id
		var id = $(this).attr('id').split('_');
		id.pop();
		id = id.join("_");
		
		//get time string
		var hours = $("#"+id+"_hour").val();
		if(hours < 10) hours = "0"+hours;
		var minutes = $("#"+id+"_minutes").val();
		if(minutes < 10) minutes = "0"+minutes;
		$("#"+id).val(hours+":"+minutes+" "+$("#"+id+"_ampm").val());
	});
	$(".time_hour").trigger('change');
});
</script><?php
		$return .= ob_get_contents();
		ob_end_clean();
	}
		
		return $return;
	}
	
	//get instructions for cms types
	public static function getInstructions($type) {
		global $site_root;
		$type = strtolower($type);
		switch($type) {
			case "php":
				return "<p>".translate('You can include PHP code as well as HTML on this page').".</p><p>".translate('You must upload images and files prior to adding them to a page').".</p><ul><li><a href='{$site_root}cms/upload/image/'>".translate('Upload Images')."</a></li><li><a href='{$site_root}cms/upload/file/'>".translate('Upload Files')."</a></li></ul>";
			case "html":
				return "<p>".translate('You must upload images and files prior to adding them to a page').".</p><ul><li><a href='{$site_root}cms/upload/image/'>".translate('Upload Images')."</a></li><li><a href='{$site_root}cms/upload/file/'>".translate('Upload Files')."</a></li></ul>";
			case "css":
				return "<p>".translate('This is a CSS style sheet').".  ".translate('Any changes made to this file will be applied to all pages that use the file').".</p>";
			case "title":
				return "<p>".translate('This is the name of the page').".  ".translate('It appears in search results and in the user\'s browser').".</p>";
			default:
				return '';
		}
	}
}
?>