<?php
cmsLogin();

$page = $_REQUEST['page'];

//if can't edit page
if(isset($acl['elements'][$page]) && $acl['elements'][$page] === 0) {
	header("Location: {$site_root}cms/edit/");
	exit();
}

//load page description and settings
ob_start();
@include SITE_FOLDER."cms/page_descriptions/$page.php"; 
$description = ob_get_contents();
ob_end_clean();

//get list of possible pages
$pages = scandir(SITE_FOLDER.'cms/page_content/');
array_shift($pages);
array_shift($pages);
$page_options = array();
foreach ($pages as $page_name ) {
	//ignore .svn and '.' and '..'
	if($page_name{0} == '.') continue;
	
	if(isset($acl['elements'][$page_name])) {
		if($acl['elements'][$page_name] === 0) {
			continue;
		}
	}
	
	$page_options[] = "<option value='$page_name' ".(($page==$page_name)? "selected='selected'" : '').">$page_name</option>";
}
$page_select = "<select id='page_select'>".implode("\n",$page_options)."</select>";

$elements_folder = SITE_FOLDER.'cms/page_content/'.$page.'/*.php';

//get list of possible element on current page
$elements = glob($elements_folder);
$element_options = array();
foreach ($elements as $element_path ) {
	$element_name = basename($element_path,'.php');
	
	$nodelete = false;
	if($acl['nodelete']) $nodelete = true;
	if(isset($acl['elements'][$page][$element_name])) {
		if($acl['elements'][$page][$element_name] === 0) continue;
		elseif($acl['elements'][$page][$element_name] !== 2) $nodelete = true;
	}
	
	$element_options[] = "<li><a href='{$site_root}cms/edit/$page/$element_name/'>$element_name</a>".
	((!$nodelete)? " - <a href='{$site_root}cms/delete_element/?page=$page&element=$element_name' style='color:red; font-size: .8em;'>".translate('delete')."</a> | " : '').
	((!$nodelete)? "<a href='{$site_root}cms/rename_element/?page=$page&element=$element_name' style=' font-size: .8em;'>".translate('rename')."</a>" : '').
	"</li>";
}

$title = translate('Choose element on')." $page";
$hidetitle = true;
include_header('cms_header');
?>
<script type='text/javascript'>
$(document).ready(function() {
	$("#page_select").change(function() {
		window.location.href=site.site_root + 'cms/edit/'+$(this).val()+'/';
	});
});
</script>
<h2><?php echo translate('Editing'); ?> <?php echo $page_select; ?></h2>
<p>

<a href='<?php echo $site_root; ?>cms/edit/'><?php echo translate('Choose Different Page'); ?></a>

<?php
if(file_exists(SITE_FOLDER."cms/pages/$page.php")) { ?>
		<?php
		if(!$acl['noeditpages'] && (!isset($acl['pages'][$page]) || $acl['pages'][$page] > 0)) {
		?>
		| <a href='<?php echo $site_root; ?>cms/edit_page/<?php echo $page;?>/'><?php echo translate('Edit This Page'); ?></a>
		<?php
		}
		if(!($acl['nodelete'] || (isset($acl['pages'][$page]) && $acl['pages'][$page] !== 2))) {
		?>
		| <a href='<?php echo $site_root; ?>cms/rename_page/?page=<?php echo $page;?>'><?php echo translate('Rename This Page'); ?></a>
		| <a href='<?php echo $site_root; ?>cms/delete_page/?page=<?php echo $page;?>' style='color:red;'><?php echo translate('Delete This Page'); ?></a>
		<?php
		}
		if(!$acl['noeditpages'] && (!isset($acl['pages'][$page]) || $acl['pages'][$page] > 0) && glob(SITE_FOLDER.'cms/revisions/'.$page.'/*.r')) {
		?>
		| <a href='<?php echo $site_root; ?>cms/revisions/?page=<?php echo $page; ?>'><?php echo translate('See revisions'); ?></a>
		<?php
		}
} 
?>
</p>
<br/>
<h3><?php echo translate('Choose Page Element To Edit'); ?></h3>
<?php 

if(!$acl['nocreate']) $element_options[] = "<li><a href='{$site_root}cms/add_element/$page/'>".translate('new')."...</a></li>";

$element_select = "<ul>".implode("\n",$element_options)."</ul>";

echo $element_select;
footer();
?>