<?php
cmsLogin();

if($_REQUEST['type'] && $_REQUEST['type']=='image') {
	$default_folder = 'uploadedimages';
}
else $default_folder = 'files';

$css_files = array('cms/jqueryFileTree');
$js_files = array('ajax','ajaxfileupload');
include_header('cms_header');
?>
<script>
var current_folder;
$(document).ready(function() {
	$("#refresh, #add_folder, #delete_folder, #delete_selected, #rename_folder, #upload").button();
	
	function get_selected_files() {
		var files = [];
		var i = 0;
		$("#fileinfo table input").each(function() {
			if($(this).attr('checked')) {
				files[i] = $(this).attr('value');
				i++;
			}
		});
		return files;
	}
	
	function select_folder(folder) {
		//store selected folder
		current_folder = folder;
		
		$("#current_path").html(current_folder.replace(/^uploadedimages/g,'images'));
		
		//disable delete_folder button if in uploadedimages/ or files/ directory
		if(current_folder == 'uploadedimages/' || current_folder == 'files/') {
			$("#delete_folder").button('disable');
			$("#rename_folder").button('disable');
		}
		else {
			$("#delete_folder").button('enable');
			$("#rename_folder").button('enable');
		}
		
		//disable delete_selected button initially
		$("#delete_selected").button('disable');
		
		//load folder content
		$.post('<?php echo $site_root; ?>cms/filelist/',{ path: folder },function(data) {
			//display data
			$("#fileinfo").html(data);
			
			//add event handlers for delete/rename links
			setLinks($("#fileinfo"));
			
			//checkbox
			$("#fileinfo table input").change(function() {
				var files = get_selected_files();
				if(files.length) {
					$("#delete_selected").button('enable');
				}
				else $("#delete_selected").button('disable');
			});
		});
	}
	
	$("#upload").click(function() {
		if(!current_folder) {
			alert('Please select a folder to upload to');
			return false;
		}
		
		call_ajax_url('<?php echo $site_root; ?>cms/upload_file/');
		
		return false;
	});
	$("#delete_folder").click(function() {
		if(!current_folder) {
			alert('Please select a folder to delete');
			return false;
		}
		if(current_folder == 'uploadedimages/' || current_folder == 'files/') {
			alert('You cannot delete this folder.');
			return false;
		}
		
		call_ajax_url('<?php echo $site_root; ?>cms/delete_folder/?name='+current_folder);
		
		return false;
	});
	$("#rename_folder").click(function() {
		if(!current_folder) {
			alert('Please select a folder to delete');
			return false;
		}
		if(current_folder == 'uploadedimages/' || current_folder == 'files/') {
			alert('You cannot rename this folder.');
			return false;
		}
		
		call_ajax_url('<?php echo $site_root; ?>cms/rename_folder/?name='+current_folder);
		
		return false;
	});
	$("#add_folder").click(function() {
		if(!current_folder) {
			return false;
		}
		
		call_ajax_url('<?php echo $site_root; ?>cms/add_folder/?name='+current_folder);
		
		return false;
	});
	$("#delete_selected").click(function() {
		if(!current_folder) {
			alert('Please select a folder first');
			return false;
		}
		var files = get_selected_files();
		if(files.length == 0) {
			alert('Please select one or more files to delete.');
			return false;
		}
		
		call_ajax_url("<?php echo $site_root; ?>cms/delete_multiple_files/?files="+arraytourl(files));
		
		return false;
	});
	$("#refresh").click(function() {
		$.get('<?php echo $site_root; ?>cms/folderlist/',null,function(data) {
			$("#file_browser").html(data);
			$("#file_browser .directory").click(function() {
				select_folder(escape($(this).find('a:first').attr('rel')));
				$("#file_browser a").removeClass('selected');
				$(this).find('a:first').addClass('selected');
				return false;
			});
			
			var temp = $("#file_browser a[rel=\""+current_folder+"\"]");
			if(!temp.length) temp = $("#<?php echo $default_folder; ?>");
			temp.click();
		});
		return false;
	}).click();
	
	ajax_events.bind('refresh_fileinfo',function() {
		if(!current_folder) {
			window.location.reload();
			return;
		}
		//reload fileinfo
		$("#file_browser a[rel=\""+current_folder+"\"]").click();
	});
	ajax_events.bind('refresh_filebrowser',function() {
		$("#refresh").click();
	});
});


function ajaxFileUpload() {
	$(".ui-dialog-buttonpane button").ajaxStart(function() {
		$(this).button('disable');
	}).ajaxComplete(function() {
		$(this).button('enable');
	});

	$.ajaxFileUpload ({
		url:'<?php echo $site_root; ?>cms/doajaxfileupload/?directory='+current_folder,
		secureuri:<?php echo $_SERVER['HTTPS']? 'true' : 'false'; ?>,
		fileElementId:'fileToUpload',
		dataType: 'json',
		success: function (data, status) {
			if(typeof(data.error) != 'undefined') {
				if(data.error != '') {
					alert(data.error);
					close_dialog();
					return false;
				}
			}
			
			ajax_events.trigger('refresh_fileinfo');
			close_dialog();
			return false;
			
		},
		error: function (data, status, e) {
			alert($.dump(data));
			alert(e);
			close_dialog();
			return false;
		}
	});
	
	return false;
}
</script>
<style>
	#fileinfo_holder, #file_browser {
		height: 320px; overflow:auto; width: 100%;
	}
	#fileinfo table {
		margin:0;
		width: 100%;
	}
	#fileinfo table, #fileinfo td, #fileinfo th {
		border-color: #ccc;
	}
	#fileinfo img {
		max-width: 300px;
		max-height: 300px;
	}
	#fileinfo pre {
		font-size: 1.3em;
		overflow:auto;
	}
	#file_browser a.selected {
		background-color: #bdf;
		font-weight:bold;
	}
	.ui-widget-header {
		font-size: .8em;
		padding: 3px;
	}
	#current_path {
		font-weight: bold;
	}
	#fileinfo p {
	font-size: 1em; margin: 5px 10px;	
	}
</style>
<h2><?php echo translate('File Manager'); ?></h2>
<p><?php echo translate('Here, you can manage all of your uploaded images and files'); ?></p>
<div class='ui-widget ui-widget-content' style='padding:0; width: 900px;'>
	<div>
		<div style='float:left; width: 200px; border-width: 0 1px 0 0;padding: 0;' class='ui-widget-content'>
			<div class='ui-widget-header'>
				<a id='refresh' class='ui-button' href='#'>Refresh</a>
			</div>
			<div style='padding: 5px;'>
			<div id='file_browser'>
			</div>
			</div>
		</div>
		<div style='float:right; padding:0; border-width: 0; width: 699px;' id='table_holder' class='ui-widget-content'>
			<div class='ui-widget-header'>
				<a id='upload' class='ui-button' href='#'>Upload</a>
				<a id='add_folder' class='ui-button' href='#'>Add Subdirectory</a>
				<a id='delete_folder' class='ui-button' href='#'>Delete Folder</a>
				<a id='rename_folder' class='ui-button' href='#'>Rename Folder</a>
				<a id='delete_selected' class='ui-button' href='#'>Delete Selected</a>
			</div>
			<div id='fileinfo_holder'>
			Current Directory: <span id='current_path'></span>
			<div id='fileinfo'></div>
			</div>
		</div>
	</div>
	<div style='clear:both;'></div>
</div>
<?php
footer();
?>