<?php
cmsLogin();

//if can't backup, go to main cms page
if($acl['nobackup']) {
	header("Location: {$site_root}cms/");
	exit();
}

// increase script timeout value
ini_set('max_execution_time', 300);

// create object
$zip = new ZipArchive();

// open archive 
list($day,$time) = explode(" ",unixtodatetime(time()));
$zip_file = 'backup_'.$day.'.zip';
$zip_path = 'backups/'.$zip_file;
$flag = (file_exists($zip_path)? ZIPARCHIVE::OVERWRITE : ZIPARCHIVE::CREATE);

$success = $zip->open($zip_path, $flag);

if ($success !== TRUE) {
    die (translate('Could not open archive').": ".$success);
}

//entire directories to add
$dirs = array(
	SITE_FOLDER.'cms/page_content/',
	SITE_FOLDER.'cms/page_descriptions/',
	SITE_FOLDER.'cms/pages/',
	SITE_FOLDER.'cms/revisions/',
	SITE_FOLDER.'cms/plugins/',
	'uploadedimages/',
	'files/'
);
//specific files to add
$files = array(
	'server/server.php',
	'.htaccess',
	'nginx.conf'
);
 
foreach($dirs as $dir) {
	// initialize an iterator
	// pass it the directory to be processed

	$iterator = new RecursiveIteratorIterator(new RecursiveDirectoryIterator($dir));

	// iterate over the directory
	// add each file found to the archive

	foreach ($iterator as $key=>$value) {
		//don't add svn files
		if(strstr($key,'.svn')) continue;
	    $zip->addFile(realpath($key), $key) or die (translate('ERROR').": ".translate('Could not add file').": $key");        
	}
}
foreach($files as $file) {
	if(!file_exists($file)) continue;
	$zip->addFile(realpath($file),$file) or die (translate('ERROR').": ".translate('Could not add file').": $file");
}


//add file that shows it is a backup
$zip->addFromString('backup_file.txt', translate('This is a backup file for the site').' '.SITE_NAME.'.  '.translate('It was created at').' '.$day.' '.$time);

// close and save archive
$zip->close();

//prompt backup download
header('Content-Disposition: attachment; filename="'.$zip_file.'"');
header('Content-type: application/zip');
readfile('backups/'.$zip_file);
exit();
?>