<style type='text/css'>
.form label {
	font-weight:bold;
	margin-right: 5px;
	vertical-align:top;
}
</style>
<script type='text/javascript'>
  function format_form(values) {
	var label = values[0];
	var type = values[1];
	var options = values[2];
	
	var id = label.replace(/[\s]+/g,'_').toLowerCase();
	
	var ret = "<label>"+label+"</label>";
	
	switch(type) {
		case "text":
			ret += "<input type='text' value=\""+options+"\"/>";
			break;
		case "date":
			ret += "<input type='text' style='width:100px;' class='date_input' value=\""+options+"\"/>";
			break;
		case "password":
			ret += "<input type='password'/>";
			break;
		case "textarea":
			ret += "<textarea cols='40' rows='3'>"+options+"</textarea>";
			break;
		case "select":
		case "dropdown":
			options = options.split(",");
			ret += "<select>";
			for(var i=0;i<options.length;i++) {
				ret += "<option>"+options[i]+"</option>";
			}
			ret += "</select>";
			break;
		case "country":
			ret += "<select><option>United States</option><option>Canada</option><option>United Kingdom</option><option>Ireland</option><option>Australia</option><option>New Zealand</option><option>-------------------</option><option>Afghanistan</option><option>Albania</option><option>Algeria</option><option>American Samoa</option><option>Andorra</option><option>Angola</option><option>Anguilla</option><option>Antarctica</option><option>Antigua and Barbuda</option><option>Argentina</option><option>Armenia</option><option>...</option></select>";
			break;
		case "state":
			ret += "<select><option>Select a State</option><option>Alabama</option><option>Alaska</option><option>Arizona</option><option>Arkansas</option><option>California</option><option>Colorado</option><option>Connecticut</option><option>Delaware</option><option>District Of Columbia</option><option>Florida</option><option>Georgia</option><option>Hawaii</option><option>Idaho</option><option>...</option></select>";
			break;
		case "captcha":
		case "verification":
			ret += "<div ><img src='<?php echo $site_root; ?>images/captcha.png' style='vertical-align:middle;'/><br/><input type='text'></div>";
			break;
		case "time":
			//time options
			options = options.split(",");
			var hour_range = options[0].split('-');
			if(hour_range.length != 2) hour_range = [9,5];
			else hour_range = [hour_range[0]*1,hour_range[1]*1];
			if(hour_range[0] > 12) hour_range[0] = 12;
			if(hour_range[1] > 12) hour_range[1] = 12;
			if(hour_range[0] < 1) hour_range[0] = 1;
			if(hour_range[1] < 1) hour_range[1] = 1;
			if(options.length > 1) {
				var minute_increment = options[1]*1;
				if(minute_increment < 1) minute_increment = 1;
				if(minute_increment > 60) minute_increment = 60;
			}
			else var minute_increment = 5;
			
			//create select elements
			ret += "<select>";
			for(var i=hour_range[0];i!=(hour_range[1]+1)%13;i = (i+1)%13) {
				if(i==0) i = 1;
				ret += "<option>"+((i<10)? '0' : '')+i+"</option>";
			}
			ret += "</select>:<select>";
			for(var i=0;i<60;i+=minute_increment) {
				ret += "<option>"+((i<10)? '0' : '')+i+"</option>";
			}
			ret += "</select> <select><option>AM</option><option>PM</option></select>";
			break;
	}
	return ret;
  }
  $(document).ready(function() {
  $("#cms_preview").bind('update',function() {
	$( ".date_input" ).datepicker({
		showOn: "both",
		buttonImage: "<?php echo $site_root; ?>images/icons/Dates.png",
		buttonImageOnly: true
	});
  });
  updatePreview();
  });
</script>
<?php
generate_csv_plugin('form',array(
	'fields'=>array(
		'label'=>array(
			'label'=>'field label',
			'id'=>'label',
			'type'=>'text'
		),
		'type'=>array(
			'label'=>'field type',
			'id'=>'type',
			'type'=>'select',
			'options'=>array(
				'text',
				'textarea',
				'date',
				'time',
				'dropdown',
				'country',
				'state',
				'password',
				'captcha'
			)
		),
		'options'=>array(
			'label'=>'options',
			'id'=>'options',
			'type'=>'textarea',
			'description'=>'When using a dropdown field, list the choices here, separated by commas'
		)
	)
));
?>