<?php
cmsLogin();

$page = $_REQUEST['page'];
$element = $_REQUEST['element'];

//page is empty
if(empty($page) || !file_exists(SITE_FOLDER."cms/pages/$page.php")) {
	header("Location: {$site_root}cms/edit/");
	exit();
}
//element is empty
elseif(empty($element) || !file_exists(SITE_FOLDER."cms/page_content/$page/$element.php")) {
	header("Location: {$site_root}cms/edit/$page/");
	exit();
}
//can't delete element
elseif($acl['nodelete'] || (isset($acl['elements'][$page]) && $acl['elements'][$page] === 0) || (isset($acl['elements'][$page][$element]) && $acl['elements'][$page][$element] !== 2)) {
	header("Location: {$site_root}cms/edit/$page/");
	exit();
}

//form submitted
if($_REQUEST['submit_rename']) {	

	//make lowercase
	$new = strtolower($_REQUEST['new']);

	//remove characters that aren't allowed
	$new = preg_replace(array('/[\s]+/','/[^a-z0-9\-_\.]/'),array('_',''),$new);
	
	if(empty($new)) {
		$error_message = alert("Please choose a valid new name.");
	}
	elseif($element===$new) {
		$error_message = alert("Type a new name in the text field.");
	}
	elseif(file_exists(SITE_FOLDER."cms/page_content/$page/$new.php")) {
		$error_message = alert("There is already another element on that page with that name.");
	}
	else {
		$errors = array();
		$references = array('pages'=>array(),'elements'=>array(),'page_revisions'=>array(),'element_revisions'=>array());
		
		//rename page_content/$page/$element.php to page_content/$page/$new.php
		if(!rename(SITE_FOLDER."cms/page_content/$page/$element.php",SITE_FOLDER."cms/page_content/$page/$new.php")) {
			$errors[] = "There was an error renaming 'page_content/$page/$element.php' to 'page_content/$page/$new.php'.";
		}
		
		//rename page_descriptions/$page/$element.php to page_descriptions/$page/$new.php
		if(!rename(SITE_FOLDER."cms/page_descriptions/$page/$element.php",SITE_FOLDER."cms/page_descriptions/$page/$new.php")) {
			$errors[] = "There was an error renaming 'page_descriptions/$page/$element.php' to 'page_descriptions/$page/$new.php'.";
		}
		
		//rename revisions/$page/$element/ to revisions/$page/$new/
		if(!rename(SITE_FOLDER."cms/revisions/$page/$element/",SITE_FOLDER."cms/revisions/$page/$new/")) {
			$errors[] = "There was an error renaming 'revisions/$page/$element/' to 'revisions/$page/$new/'.";
		}
		
		//replace references in the element's page
		$pcontent = file_get_contents(SITE_FOLDER."cms/pages/$page.php");
		$pcontent2 = preg_replace('/\[cms\][\s]*'.$element.'[\s]*\[\/cms\]/',"[cms]{$new}[/cms]",$pcontent);
		
		if($pcontent2 !== $pcontent) {
			file_put_contents(SITE_FOLDER."cms/pages/$page.php",$pcontent2);
			$references['pages'][] = $page;
		}
		
		//loop through all pages
		$pages = glob(SITE_FOLDER."cms/pages/*.php");
		foreach($pages as $p) {
			$p = basename($p,'.php');
			
			//replace references in page itself
			$pcontent = file_get_contents(SITE_FOLDER."cms/pages/$p.php");
			$pcontent2 = preg_replace(array('/\[cms\][\s]*'.$page.'[\s]*-[\s]*'.$element.'[\s]*\[\/cms\]/','/CMS::load\([\s]*[\'"]'.$page.'[\'"][\s]*,[\s]*[\'"]'.$element.'[\'"][\s]*\)/'),array("[cms]$page - {$new}[/cms]","CMS::load('$page','$new')"),$pcontent);
			
			if($pcontent2 !== $pcontent) {
				file_put_contents(SITE_FOLDER."cms/pages/$p.php",$pcontent2);
				$references['pages'][] = $p;
			}
			
			//loop through page revisions
			$rev = glob(SITE_FOLDER."cms/revisions/$p/*.r");
			$rev[] = SITE_FOLDER."cms/revisions/$p/current.txt";
			foreach($rev as $r) {
				if(!file_exists($r)) continue;
				$r = basename($r);
				$rcontent = file_get_contents(SITE_FOLDER."cms/revisions/$p/$r");
				$rcontent2 = preg_replace(array('/\[cms\][\s]*'.$page.'[\s]*-[\s]*'.$element.'[\s]*\[\/cms\]/','/CMS::load\([\s]*[\'"]'.$page.'[\'"][\s]*,[\s]*[\'"]'.$element.'[\'"][\s]*\)/'),array("[cms]$page - {$new}[/cms]","CMS::load('$page','$new')"),rcontent2);
			
				if($rcontent2 !== $rcontent) {
					file_put_contents(SITE_FOLDER."cms/revisions/$p/$r",$rcontent2);
					$references['page_revisions'][] = array($p,$r);
				}
			}
			
			//loop through page elements
			$elements = glob(SITE_FOLDER."cms/page_content/$p/*.php");
			foreach($elements as $e) {
				$e = basename($e,'.php');
				
				//replace references in element
				$econtent = file_get_contents(SITE_FOLDER."cms/page_content/$p/$e.php");
				$econtent2 = preg_replace('/\[cms\][\s]*'.$page.'[\s]*-[\s]*'.$element.'[\s]*\[\/cms\]/',"[cms]$page - {$new}[/cms]",$econtent);
			
				if($econtent2 !== $econtent) {
					file_put_contents(SITE_FOLDER."cms/page_content/$p/$e.php",$econtent2);
					$references['elements'][] = array($p,$e);
				}
				
				//loop through element revisions
				$rev = glob(SITE_FOLDER."cms/revisions/$p/$e/*.r");
				$rev[] = SITE_FOLDER."cms/revisions/$p/$e/current.txt";
				foreach($rev as $r) {
					if(!file_exists($r)) continue;
					$r = basename($r);
					$rcontent = file_get_contents(SITE_FOLDER."cms/revisions/$p/$e/$r");
					$rcontent2 = preg_replace('/\[cms\][\s]*'.$page.'[\s]*-[\s]*'.$element.'[\s]*\[\/cms\]/',"[cms]$page - {$new}[/cms]",$rcontent2);
				
					if($rcontent2 !== $rcontent) {
						file_put_contents(SITE_FOLDER."cms/revisions/$p/$e/$r",$rcontent2);
						$references['element_revisions'][] = array($p,$e,$r);
					}
				}
			}
		}
		
		if($errors) {
			$error_message = alert(implode("<br/>",$errors)."<br/>You will have to manually rename these files and folders.");
		}
		else {
			$msg = '';
			if(!empty($references['pages'])) {
				$msg .= "<strong>Pages:</strong><ul>";
				foreach($references['pages'] as $p) {
					$msg .= "<li>$p - <a href='{$site_root}cms/edit_page/$p/'>edit</a></li>";
				}
				$msg .= "</ul>";
			}
			if(!empty($references['elements'])) {
				$msg .= "<strong>Elements:</strong><ul>";
				foreach($references['elements'] as $e) {
					$p = $e[0];
					$e = $e[1];
					
					$msg .= "<li>$p &gt; $e - <a href='{$site_root}cms/edit_page/$p/$e/'>edit</a></li>";
				}
				$msg .= "</ul>";
			}
			if($msg) {
				$title = translate('Rename Element');
				include_header('cms_header');
				echo notice("The element was successfully renamed");
				?>
				<p>The following references were updated:</p>
				<?php
				echo $msg;
				?>
				<p><a href='<?php echo $site_root; ?>cms/edit/<?php echo $page; ?>/'><?php echo translate('Back To Page'); ?></a></p>
				<?php
				footer();
				exit();
			}
			else {
				header("Location: {$site_root}cms/edit/$page/");
				exit();
			}
		}
	}
}

$title = translate('Rename Element');
include_header('cms_header');

//needs to choose new name
?>
	<p>This will rename the element and update all references to the element throughout the site.  Updating the references may take some time for larger sites, so please be patient.</p>
<?php
	if($error_message) echo $error_message;
?>
	<form method='post' action='<?php echo $site_root.$current_path; ?>'>
		Rename
		<div style='margin-left: 10px;'><strong><?php echo $page; ?></strong> &gt; <strong><?php echo $element; ?></strong></div>
		to
		<div style='margin-left: 10px;'><strong><?php echo $page; ?></strong> &gt; <input type='text' name='new' />
		<input type='hidden' name='page' value='<?php echo $page; ?>' /></div>
		<input type='hidden' name='element' value='<?php echo $element; ?>' />
		<br/>
		<input type='submit' class='ui-button ui-state-default ui-corner-all' value='Rename' name='submit_rename' />
		<a href='<?php echo $site_root; ?>cms/edit/<?php echo $page; ?>/'>Cancel</a>
	</form>
<?php
footer();
?>