<?php
cmsLogin();

include "includes/finediff.php";

$page = $_REQUEST['page'];
$element = $_REQUEST['element'];

$revision = $_REQUEST['revision'];

$word = (empty($element)? 'page' : 'element');

$current = false;
$time = explode('.',$revision);
$time = array_shift($time);

$file_location = SITE_FOLDER.'cms/revisions/'.$page.(empty($element)? '' : '/'.$element).'/'.$revision.'.r';

$current_location = SITE_FOLDER.'cms/'.(empty($element)? "pages/$page.php" : "page_content/$page/$element.php");

$return_link = "{$site_root}cms/revisions/?page=$page&element=$element";

$title = "Revision Diff";
if(!file_exists($file_location) || !file_exists($current_location)) {
	include_header('cms_header');
	?>
	<p><?php echo translate('The '.$word.' or the selected revision cannot be found'); ?>.  <a href='<?php echo $return_link; ?>'><?php echo translate('Go Back'); ?></a></p>
	<?php
	footer();
	exit();
}
else {
	$style = "
		del {
			background-color: #ffcccc;
		}
		ins {
			background-color: #ccffcc;
		}
		.preview {
		width: 100%;
		}
		.preview div {
			border:1px solid black;
			width: 100%;
			height: 300px;
			overflow: auto
		}
	";
	include_header('cms_header');
	echo "<p>".ucfirst(translate($word)).": <strong>$page</strong>".(empty($element)? '' : " > <strong>$element</strong>")."</p>";
	echo "<p><a href='$return_link'>".translate('Back To Revisions')."</a></p>";
	
	$old = file_get_contents($current_location);
	$new = file_get_contents($file_location);
	echo "<div class='preview'><ins>".translate('Revision')." ".date("m/d/Y g:i:s a",$time)."</ins> ".translate('compared to')." <del>".translate('Current Revision')."</del><div>" . nl2br(htmlDiff($old,$new)) . "</div></div>";
	footer();
	exit();
}

function htmlDiff($old,$new) {
	$opcodes = FineDiff::getDiffOpcodes($old, $new,FineDiff::$wordGranularity);
	return FineDiff::renderDiffToHTMLFromOpcodes($old, $opcodes);
}

?>