//the link object used to start current ajax activity
var ajax_link;

//a holder for ajax events
var ajax_events = $("<div>");

//function called when submitting a dialog form
function submit_dialog() {
	//get elements
	var dialog = $("#dialog");
	var form = $("form",dialog);
	
	//get submit url from form action 
	var url = form.attr('action');
	
	var alert_string = url+"?";
	
	//loop through form and generate params object
	var params = new Object();
	$(":input",form).each(function() {
		params[$(this).attr('name')] = $(this).val();
		alert_string += $(this).attr('name')+"="+$(this).val()+"&";
	});
	params['submit'] = "true";
	params['confirm'] = "true";
	params['ajax'] = "true";
	
	//alert("Submitting to "+alert_string);
	
	//call url with params and callback
	$.get(url,params,handleAjaxResponse,'json');
}
//wrapper function for closing dialog box
function close_dialog() {
	$("#dialog").dialog('close');
}

//function to handle ajax responses
function handleAjaxResponse(response) {

	//close any previous dialog
	close_dialog();
	
	//alert($.dump(response));
	
	//redirect to new page
	if(response.load_page) {
		window.location.href = response.load_page;
		return;
	}
	
	//trigger ajax events
	if(response.trigger) {		
		//trigger event
		for(var i=0;i<response.trigger.length;i++) {
			ajax_events.trigger(response.trigger[i].trigger, response.trigger[i].parameters);
		}
	}
	
	//close site notices/alerts
	if(response.hide_alert) {
		$("#site_alert").hide();
	}
	if(response.hide_notice) {
		$("#site_notice").hide();
	}
	
	//site notice/alert
	if(response.alert) {
		var target = $("#site_alert");
	
		$(".text",target).html(response.alert);
		setLinks($(".text",target));
		target.show();
	}
	if(response.notice) {
		var target = $("#site_notice");
	
		$(".text",target).html(response.notice);
		setLinks($(".text",target));
		target.show();
	}
	
	//reload closest parent div with title or whole page
	if(response.reload_parent) {
		//get reload target
		var reload_target = ajax_link.parents(".ui-widget:first");
		
		reload_target = $(".hasTitle",reload_target);
		
		//if no reloadable div, reload page
		if(reload_target.length==0) {
			window.location.reload(true);
		}
		
		//reload content div of link
		else reloadDiv(reload_target);
	}
	
	//reload multiple divs by id
	if(response.reload) {	
		//loop through div ids
		for(var i=0;i<response.reload.length;i++) {
			var target = response.reload[i];
			if(!empty(target))	reloadDiv($("#"+target));
		}
	}
	
	//load multiple divs by id and url
	if(response.load) {		
		for(var i=0;i<response.load.length;i++) {
			var url = response.load[i].url;
			var target = response.load[i].target;
			if(!empty(target))	loadDiv(url,$("#"+target));
		}
	}
	
	//run javascript
	if(response.javascript) {
		var javascript = $.trim(response.javascript);
		if(!empty(javascript)) eval(javascript);
	}
	
	//parse response text and display dialog
	if(response.dialog) {
		//get dialog object
		var dialog = $("#dialog");		
		
		var js = response.js;
		var header = response.header;
		var html = response.html;
		var parameters = response.parameters;
		
		if(empty(js)) js = '';
		if(empty(header)) header = '';
		if(empty(parameters)) parameters = '';
		if(empty(html)) html = '';
		
		//destroy old dialog
		dialog.dialog('destroy');
		
		//create dialog options
		var options = new Object();
		for(i=0;i<parameters.length;i++) {
			var parameter = parameters[i].name;
			var value = parameters[i].value;
			
			if(empty(parameter)) continue;
			
			//if parameter is "buttons"
			if(parameter=="buttons") {
				//no buttons
				if(value.length == 0) continue;
				var buttons = value;
				
				value = new Object();
				for(j=0;j<buttons.length;j++) {
					var button_name = buttons[j].display;
					var function_name = buttons[j].action;
					var func;
					
					if(empty(function_name)) continue;
					
					//common functions
					if(function_name=="submit_dialog()") func = submit_dialog;
					else if(function_name=="close_dialog()") func = close_dialog;
					else func = new Function(function_name+";");			
					value[button_name] = func;
				}
			}
			
			//convert to integer if needed
			if(parameter=='width'||parameter=='minWidth'||parameter=='height'||parameter=='minHeight') value = 1*value;
			
			options[parameter] = value;
		}
		
		//set default parameters
		if(empty(options['minWidth'])) options['minWidth'] = 400;
		if(empty(options['width'])) options['width'] = 400;
		if(empty(options['modal'])) options['modal'] = false;
		if(empty(options['title'])) options['title'] = header;
		if(empty(options['zIndex'])) options['zIndex'] = 100;
		
		//load html into dialog
		dialog.html(html);
		
		//stop form from submitting
		$("form",dialog).submit(function() {
			return false;
		});
		
		//open dialog
		dialog.dialog(options);
		
		//run javascript
		if(!empty(js)) eval(js);
	}
	
	return;
}

//div loading/reloading functions
var div_urls = new Object(); //holds urls for divs
function loadDiv(url, div, callback) {
	if(callback==null || typeof(callback)=="undefined" || callback=="") callback = false;
	
	//if div has a title, move over to div_urls object
	if(div.attr('title').length>0) {
		div_urls[div.attr('id')] = div.attr('title');
		div.attr('title','');
	}
	
	//save old url
	var old_url = div_urls[div.attr('id')];
	
	//set new url
	div_urls[div.attr('id')] = url;
	
	//if content wasn't loaded, change url back
	if(!reloadDiv(div, callback)) div_urls[div.attr('id')] = old_url;
}
function reloadDiv(div, callback) {
	if(typeof(callback)!="function") callback = function(){};
	
	//if div has title attribute set, move it over to div_urls object
	removeTitles();
	
	//get url from "title" attribute of div
	var url = div_urls[div.attr('id')];
	
	if(url!=null && typeof(url)!="undefined" && url!="" && url!=false) {		
		div.load(url,null,function (responseText, textStatus, XMLHttpRequest) {
			setLinks($(this));
			$(this).trigger('reload');
			callback();
		});
		return true;
	}
	else return false;
}

//function to attach ajax calls to links
function setLinks(limit) {
	if(typeof(limit)!='object') limit = document;
	
	links = $(".ajax_link",limit);
	
	//set button styles
	$('.ui-state-default',limit)
	.hover(
		function(){$(this).addClass('ui-state-hover');},
		function(){$(this).removeClass('ui-state-hover');}
	)
	.mousedown(function(){$(this).addClass('ui-state-active');})
	.mouseup(function(){$(this).removeClass('ui-state-active');})
	.mouseout(function(){$(this).removeClass('ui-state-active');});
	
	//attach ajax calls to links
	links.each(function() {
		//use a named function, so it is only bound once to the click event
		$(this).unbind('click',setLink);
		$(this).bind('click',setLink);
	});
}

function call_ajax_url(url) {
	//attach "ajax=true" to url if it's not already there
	if(url.indexOf("ajax=true")==-1) {
		if(url.indexOf("?")!=-1) url += "&ajax=true";
		else url += "?ajax=true";
	}
	
	ajax_link = null;
	
	//call url
	$.get(url,null,handleAjaxResponse,'json');
}

function setLink() {
	//get url from link
	var url = $(this).attr('href');
	
	//attach "ajax=true" to url if it's not already there
	if(url.indexOf("ajax=true")==-1) {
		if(url.indexOf("?")!=-1) url += "&ajax=true";
		else url += "?ajax=true";
	}
	
	//store link so if ajax response is "reload", we can figure out what div to reload
	ajax_link = $(this);
	
	//call url
	$.get(url,null,handleAjaxResponse,'json');
	
	return false;	
}

//removes title attributes from divs and stores them in object
function removeTitles() {
	$("div[title]").each(function() {
		if($(this).attr('title').length>0) {
			div_urls[$(this).attr('id')] = $(this).attr('title');
			$(this).attr('title','').addClass('hasTitle');
		}
	});
}

//remove title attribute from divs
$(document).ready(function() {
	//make dialog containing div if it doesn't exist
	var dialog = $("div#dialog");
	if(dialog.length==0) {
		dialog = $("<div id='dialog'></div>");
		$('body').append(dialog);
	}

	removeTitles();
	
	setLinks(false);
});
