$(document).ready(function() {
	//buttons
	$('.ui-state-default').hover(
		function(){$(this).addClass('ui-state-hover');},
		function(){$(this).removeClass('ui-state-hover');}
	)
	.mousedown(function(){$(this).addClass('ui-state-active');})
	.mouseup(function(){$(this).removeClass('ui-state-active');})
	.mouseout(function(){$(this).removeClass('ui-state-active');});

	//collapsing ui-widget-contents
	$('a.collapse').each(function() {
		var hidetext,showtext;
	
		if($(this).html().length >0) hidetext = $(this).html();
		else hidetext = 'hide';
		
		if($(this).attr('rel').length >0) showtext = $(this).attr('rel');
		else showtext = 'show';
		
		//if controls multiple divs
		if($(this).attr('target').length > 0) {
			$(this).click(function() {
				var elems = $(this).attr('target').split('|');
				for(var i=0;i<elems.length;i++) {
					var newstyle = $(elems[i]).toggle().css('display');
					if(newstyle=='none') $(this).html(showtext);
					else $(this).html(hidetext);
				}
				return false;
			});
		}
		
		//if only controls 1 div
		else {
			//get element
			var widget = $(this).parents(".ui-widget:first");
			var element = widget.children(".ui-widget-content:first");
			
			//determine text based on current state
			if(element.css('display')=='none') $(this).html(showtext);
			else $(this).html(hidetext);
			
			$(this).click(function() {
				var url;
				var newstyle = element.toggle().css('display');
				
				collapse_widget_content = element;
				
				if(newstyle=='none') {
					$(this).html(showtext);
					url = site.linkpref+'user/set_preference/'+widget.attr('id')+'/showhide/hide/?page='+site.path;
				}
				else {
					$(this).html(hidetext);
					url = site.linkpref+'user/set_preference/'+widget.attr('id')+'/showhide/show/?page='+site.path;
				}
				
				$.get(url,{ajax:'true'});
				
				return false;
			});
		}
	});
	
	//links that submit forms
	$("a.submit_form").each(function() {
		var form = $(this).parents('form:first');
		$(this).click(function() {
			form.submit();
			return false;
		});
	});
});
/**
 * jquery.dump.js
 * @author Torkild Dyvik Olsen
 * @version 1.0
 * 
 * A simple debug function to gather information about an object.
 * Returns a nested tree with information.
 * 
 */
(function($) {

$.fn.dump = function() {
   return $.dump(this);
}

$.dump = function(object) {
   var recursion = function(obj, level) {
      if(!level) level = 0;
      var dump = '', p = '';
      for(i = 0; i < level; i++) p += "\t";
      
      t = type(obj);
      switch(t) {
         case "string":
            return '"' + obj + '"';
            break;
         case "number":
            return obj.toString();
            break;
         case "boolean":
            return obj ? 'true' : 'false';
         case "date":
            return "Date: " + obj.toLocaleString();
         case "array":
            dump += 'Array ( \n';
            $.each(obj, function(k,v) {
               dump += p +'\t' + k + ' => ' + recursion(v, level + 1) + '\n';
            });
            dump += p + ')';
            break;
         case "object":
            dump += 'Object { \n';
            $.each(obj, function(k,v) {
               dump += p + '\t' + k + ': ' + recursion(v, level + 1) + '\n';
            });
            dump += p + '}';
            break;
         case "jquery":
            dump += 'jQuery Object { \n';
            $.each(obj, function(k,v) {
               dump += p + '\t' + k + ' = ' + recursion(v, level + 1) + '\n';
            });
            dump += p + '}';
            break;
         case "regexp":
            return "RegExp: " + obj.toString();
         case "error":
            return obj.toString();
         case "document":
         case "domelement":
            dump += 'DOMElement [ \n'
                  + p + '\tnodeName: ' + obj.nodeName + '\n'
                  + p + '\tnodeValue: ' + obj.nodeValue + '\n'
                  + p + '\tinnerHTML: [ \n';
            $.each(obj.childNodes, function(k,v) {
               if(k < 1) var r = 0;
               if(type(v) == "string") {
                  if(v.textContent.match(/[^\s]/)) {
                     dump += p + '\t\t' + (k - (r||0)) + ' = String: ' + trim(v.textContent) + '\n';
                  } else {
                     r--;
                  }
               } else {
                  dump += p + '\t\t' + (k - (r||0)) + ' = ' + recursion(v, level + 2) + '\n';
               }
            });
            dump += p + '\t]\n'
                  + p + ']';
            break;
         case "function":
            var match = obj.toString().match(/^(.*)\(([^\)]*)\)/im);
            match[1] = trim(match[1].replace(new RegExp("[\\s]+", "g"), " "));
            match[2] = trim(match[2].replace(new RegExp("[\\s]+", "g"), " "));
            return match[1] + "(" + match[2] + ")";
         case "window":
         default:
            dump += 'N/A: ' + t;
            break;
      }
      
      return dump;
   }
   
   var type = function(obj) {
      var type = typeof(obj);
      
      if(type != "object") {
         return type;
      }
      
      switch(obj) {
         case null:
            return 'null';
         case window:
            return 'window';
         case document:
            return 'document';
         case window.event:
            return 'event';
         default:
            break;
      }
      
      if(obj.jquery) {
         return 'jquery';
      }
      
      switch(obj.constructor) {
         case Array:
            return 'array';
         case Boolean:
            return 'boolean';
         case Date:
            return 'date';
         case Object:
            return 'object';
         case RegExp:
            return 'regexp';
         case ReferenceError:
         case Error:
            return 'error';
         case null:
         default:
            break;
      }
      
      switch(obj.nodeType) {
         case 1:
            return 'domelement';
         case 3:
            return 'string';
         case null:
         default:
            break;
      }
      
      return 'Unknown';
   }
   
   return recursion(object);
}

function trim(str) {
   return ltrim(rtrim(str));
}

function ltrim(str) {
   return str.replace(new RegExp("^[\\s]+", "g"), "");
}

function rtrim(str) {
   return str.replace(new RegExp("[\\s]+$", "g"), "");
}

})(jQuery);

function empty(text) {
	if(typeof(text)=="undefined") return true;
	else if(text == 0) return true;
	else if(text == "") return true;
	else return false;
}
function arraytourl(arr, del) {
	if(!del) del = '|';
	return encodeURIComponent(arr.join(del));
}